%define ver     0.2.3
%define rel 15mdk

%define	CTVER	%{ver}
%define	CDVER	1999.08.29
%define MDK_KBD_VER 20000831

# /usr/lib/kbd/{conslefonts,consolemaps,keymaps} instead of
# /usr/share/{conslefonts,consolemaps,keymaps}
%define _datadir	%{_libdir}/kbd

Summary: Linux console tools
Name: console-tools
Version: %{ver}
Release: %{rel}
Group: Terminals
Exclusiveos: Linux
Copyright: GPL
URL: http://www.altern.org/ydirson/en/lct/
Source0: ftp://metalab.unc.edu/pub/Linux/system/keyboards/console-tools-%{CTVER}.tar.bz2
Source1: ftp://metalab.unc.edu/pub/Linux/system/keyboards/console-data-%{CDVER}.tar.bz2
Source2: keytable.init
Source3: ftp://ftp.dementia.org/pub/linux/pc2sun.pl
Source4: console-tools-ucwfonts.tar.bz2
Source5: kbd-0.96-turkish.tar.bz2
Source6: kbd-mdk-keymaps-%{MDK_KBD_VER}.tar.bz2
Source7: configure_keyboard.sh
Source8: ctools-cyr.tar.bz2

Patch0: console-tools-1998.08.11.resizecons.patch.bz2
# Patch below is obsolete
#Patch1: console-tools-1999.08.29.sparc.patch.bz2
#Patch2: console-tools-1998.08.11.sparc2.patch
Patch3: console-tools-1999.03.02.sparc3.patch.bz2
# Allow consolechars & loadkeys to run from the root partition
Patch6: console-tools-rootpart.patch.bz2
# Add /etc/sysconfig/console (without subdirs) to the search path
Patch7: console-tools-searchpath.patch.bz2

Patch10: console-data-1999.08.29-mandrake.patch.bz2

Prereq: /sbin/chkconfig fileutils sed
Obsoletes: kbd
Provides: kbd
BuildRequires: libtool >= 1.3.3, sgml-tools
Requires: grep, /bin/gawk
Buildroot: %{_tmppath}/console-tools-root

%package devel
Summary: devel for linux console tools
Group: Terminals

%description
This package contains utilities to load console fonts and
keyboard maps.  It also includes a number of different fonts
and keyboard maps.

%description devel
devel package for %{name}

%prep

%setup -n console-tools-%{CTVER} -q -a 1
cd console-data-%{CDVER}
tar xyf %SOURCE4
tar xyf %SOURCE5
%patch10 -p1
cd ..

%ifarch sparc sparc64
# (fg) Patches below all apply to a directory named data
mv console-data-%{CDVER} data
#%patch1 -p1
%patch3 -p1
mv data console-data-%{CDVER}
%endif

%patch6 -p1 -b .rootpart
#%patch7 -p1 -b .searchpath

%build
%ifarch i386 i486 i586 i686 k6 k7
DISABLE_RESIZECONS=
%else
DISABLE_RESIZECONS=--disable-resizecons
%endif

# that way, get uptodate libtool (for config.sub)
#libtoolize --force

CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE"
%configure --enable-localdatadir=/etc/sysconfig/console $DISABLE_RESIZECONS
make

cd console-data-%{CDVER}
CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE"
%configure --enable-localdatadir=/etc/sysconfig/console $DISABLE_RESIZECONS
make
cd ..

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr

%makeinstall
cd console-data-%{CDVER}
%makeinstall
cd ..

# XXX hotwire some fonts on sun
# (fg) Unnecessary, all fonts are already in the package
# FIXME though: in RH, RUSCII* are ruscii* in mdk

#%ifarch sparc sparc64
#XXXFONTS="
#    RUSCII_8x14.psf.gz RUSCII_8x16.psf.gz RUSCII_8x8.psf.gz
#    koi8u-8x14.psf.gz koi8u-8x16.psf.gz koi8u-8x8.psf.gz
#    lat2u-16.psf.gz latin5-16.psf.gz 
#    ucw08.psf.gz  ucw11m.psf.gz ucw11z.psf.gz ucw16.psf.gz
#"
#make -C console-data-%{CDVER}/consolefonts $XXXFONTS
#for F in $XXXFONTS
#do
#  install -c -m 0644 console-data-%{CDVER}/consolefonts/$F $RPM_BUILD_ROOT/usr/lib/kbd/consolefonts/$F
#done
#%endif

# don't give loadkeys SUID perms
chmod 755 $RPM_BUILD_ROOT/%{_bindir}/loadkeys

# other keymaps
tar yxvf $RPM_SOURCE_DIR/kbd-mdk-keymaps-%{MDK_KBD_VER}.tar.bz2 \
      -C $RPM_BUILD_ROOT/%{_libdir}/kbd/
tar yxvf $RPM_SOURCE_DIR/ctools-cyr.tar.bz2 \
      -C $RPM_BUILD_ROOT/%{_libdir}/kbd/
	  
install -d -m 755 $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 $RPM_SOURCE_DIR/keytable.init $RPM_BUILD_ROOT/etc/rc.d/init.d/keytable

mkdir -p $RPM_BUILD_ROOT/etc/profile.d
install -m 755 $RPM_SOURCE_DIR/configure_keyboard.sh \
	$RPM_BUILD_ROOT/etc/profile.d/configure_keyboard.sh

mkdir -p $RPM_BUILD_ROOT/bin
for foo in loadkeys consolechars ; do
  mv $RPM_BUILD_ROOT/usr/bin/$foo $RPM_BUILD_ROOT/bin
  ln -s ../../bin/$foo $RPM_BUILD_ROOT/usr/bin/$foo
done

%ifarch sparc sparc64
install -m 755 $RPM_SOURCE_DIR/pc2sun.pl $RPM_BUILD_ROOT/%{_libdir}/kbd/keytables
%endif

%ifnarch i386 i486 i586 i686 k6 k7
rm -f $RPM_BUILD_ROOT/%{_mandir}/man8/resizecons.8
%endif

chmod +x $RPM_BUILD_ROOT/%{_libdir}/*.so*

cp -aR console-data-%{CDVER}/doc/* doc

# it is the same file; a symlink will save some space
ln -sf UnicodeData-2.1.8.txt $RPM_BUILD_ROOT%{_libdir}/kbd/unidata/UnicodeData-2.txt

#
install -m644 -D include/lct/*.h %buildroot/%{_includedir}/lct/

%clean
#rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
/sbin/chkconfig --add keytable
if [ -f /etc/sysconfig/keyboard ] ; then
    . /etc/sysconfig/keyboard
    if [ -n "$KEYTABLE" ] ; then
        KT=`echo $KEYTABLE | sed -e "s/.*\///g" | sed -e "s/\..*//g"`
        echo "KEYTABLE=$KT" > /etc/sysconfig/keyboard
    fi
fi
if [ -f /etc/sysconfig/i18n ] ; then
   . /etc/sysconfig/i18n
   if [ -d /etc/sysconfig/console ] ; then
      if [ -n "$SYSFONT" ]; then
         cp -f %{_libdir}/kbd/consolefonts/$SYSFONT* /etc/sysconfig/console
      fi
      if [ -n "$UNIMAP" ]; then
         cp -f %{_libdir}/kbd/consoletrans/$UNIMAP* /etc/sysconfig/console
      fi
      if [ -n "$SYSFONTACM" ]; then 
         cp -f %{_libdir}/kbd/consoletrans/$SYSFONTACM* /etc/sysconfig/console
      fi
   fi
fi

%preun
if [ $1 = 0 ]; then
   /sbin/chkconfig --del keytable
fi

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)

%doc README NEWS RELEASE

%config(noreplace) /etc/profile.d/configure_keyboard.sh

%config(noreplace) /etc/rc.d/init.d/keytable

%{_libdir}/*.so.*
%dir %{_libdir}/kbd
%{_libdir}/kbd/consolefonts
%{_libdir}/kbd/consoletrans
%dir %{_libdir}/kbd/keymaps
%{_libdir}/kbd/unidata
%{_libdir}/kbd/keymaps/include
# Warning: keyboards are not cpu-dependent but machine-dependent.
# How to distinguish Linux/PPC on Amiga/PPC (amiga kbd) and Linux/PPC
# on Apple/ppc (mac kbd) ?
#
# for now an ugly hack: ppc -> mac, sparc -> sun, i386/alpha -> i386
#%{_libdir}/kbd/keymaps/amiga
#%{_libdir}/kbd/keymaps/atari
%ifarch i386 i486 i586 i686 k6 k7 alpha
%{_libdir}/kbd/keymaps/i386
%endif
%ifarch ppc
%{_libdir}/kbd/keymaps/mac
%endif
%ifarch sparc sparc64
%{_libdir}/kbd/keymaps/sun
%endif
/bin/consolechars
/bin/loadkeys
%{_bindir}/charset
%{_bindir}/chvt
%{_bindir}/codepage
%{_bindir}/consolechars
%{_bindir}/deallocvt
%{_bindir}/dumpkeys
%{_bindir}/fgconsole
%{_bindir}/getkeycodes
%{_bindir}/kbd_mode
%{_bindir}/loadkeys
%{_bindir}/loadunimap
%{_bindir}/mk_modmap
%{_bindir}/mapscrn
%{_bindir}/psfaddtable
%{_bindir}/psfgettable
%{_bindir}/psfstriptable
%ifarch i386 i468 i586 i686 k6 k7
%{_bindir}/resizecons
%endif
%{_bindir}/saveunimap
%{_bindir}/screendump
%{_bindir}/setfont
%{_bindir}/setkeycodes
%{_bindir}/setleds
%{_bindir}/setmetamode
%{_bindir}/setvesablank
%{_bindir}/showcfont
%{_bindir}/showkey
%{_bindir}/unicode_start
%{_bindir}/unicode_stop
%{_bindir}/vcstime
%{_bindir}/vt-is-UTF8
%{_bindir}/writevt

%{_mandir}/man1/*
%{_mandir}/man4/*
%{_mandir}/man5/*
%{_mandir}/man8/*


%files devel
%defattr(-,root,root)
%doc BUGS TODO doc/[cdf]* doc/keymaps doc/README* doc/*.txt
%{_libdir}/*.a
%{_libdir}/*.so
%{_includedir}/lct/

%changelog
* Wed Sep 20 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.2.3-15mdk
- Add include files to devel package.

* Sat Sep  2 2000 Pixel <pixel@mandrakesoft.com> 0.2.3-14mdk
- remove pablo's hack for stty failing (completly removed the stty stuff until
someone find something better)

* Fri Sep  1 2000 Pixel <pixel@mandrakesoft.com> 0.2.3-13mdk
- move the *.a and *.so in the -devel package

* Thu Aug 31 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 0.2.3-12mdk
- added various keyboards and fonts, to sync whith what is offered by DrakX

* Wed Aug 30 2000 Frederic Lepied <flepied@mandrakesoft.com> 0.2.3-11mdk
- use /var/lock/subsys file to avoid relaunch in run level change.

* Thu Jul 27 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 0.2.3-10mdk
- fixed Japanese 106keys keyboard

* Fri Jul 21 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 0.2.3-9mdk
- fix Swiss romand keyboard

* Thu Jul 20 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 0.2.3-8mdk
- make sure meta_keys.inc file is included for the sparc
- use mandir macros
- added Tamil console font
- some keyboard fixes

* Tue Jun 20 2000 Frederic Lepied <flepied@mandrakesoft.com> 0.2.3-7mdk
- fixed configure_keyboard.sh to not run in non-interactive sessions.

* Mon Jun  5 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.2.3-6mdk
- Remove nasty stuff from pablo.

* Mon Jun 05 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 0.2.3-5mdk
- a tar file was not installed due to wrong format, fixed

* Fri May 26 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 0.2.3-4mdk
- fixed Swedish keyboard
- added more keyboards to be in sync with DrakX
- added cyrillic add-ons from IP-Labs

* Mon May 22 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 0.2.3-3mdk
- removed no longer needed call to setsysfont

* Tue May  9 2000 Frederic Lepied <flepied@mandrakesoft.com> 0.2.3-2mdk
- fixed sparc compile.

* Wed Apr 19 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 0.2.3-1mdk
- updated to 0.2.3
- fixed some files permissions
- made the BackSpace key configuration (eg sending ^H or ^?)
  consistent accross platforms (SUN, mac and PC)
- make the three supplementary keys of PC 105 keys kbds, and the 
  three keys meta(L,R) and Compose on SUNs, behave the same.
- corrected Brazilian keyboard
- updated Swedish keyboard

* Fri Apr 14 2000 David BAUDENS <baudens@mandrakesoft.com> 0.2.2-15mdk
- Add missing x86 archs

* Wed Mar 29 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 0.2.2-14mdk
- Oops, /usr/lib/lib* were missing... fixed

* Wed Mar 29 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 0.2.2-13mdk
- in %%files section only kmaps for the building target (needs improving)
- new Group: naming
- new armenian keyboards
- included the sun4 norwegian keyboard in our kbd-mdk tarball; it's easier

* Wed Mar 08 2000 Pablo Saratxaga <pablo@mandrakesoft.com> 0.2.2-12mdk
- corrected the keyboard map "il-8859_8.kmap" (keyboard used in Israel),
  it was wrongly identiqual to "hebrew.kmap" (phonetical keyboard)

* Sat Jan 15 2000 Francis Galiegue <francis@mandrakesoft.com>
- sparc patch fixing galore
- bzip2'ed all patches which weren't
- spec file fixes

* Tue Jan 11 2000 Pixel <pixel@mandrakesoft.com>
- alphaev6 adaptation (libtoolize call added)
- buildreq sgml-tools added (for sgml2html)

* Fri Jan  7 2000 Pixel <pixel@mandrakesoft.com>
- really hide output of loadkeys (msg4pablo: >& is csh, not sh :pp)

* Tue Jan  4 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.2.2-8mdk
- remove configure_keyboard.sh.

* Mon Jan 03 2000 Pablo Saratxaga <pablo@mandrakesoft.com>
- Hide outpout of loadkeys {backspace,delete}.in, 
  only show the [OK] or [FAILED].
- added a cp852 encoded version of the "t" font.

* Thu Dec 30 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- improved the BackSpace key handling
- added fonts for latin7 and latin8, and various trans and uni files

* Mon Dec 27 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- corrected the problem with the euro.inc file (the keysyms are locale
  dependent! the names 'currency' and 'cent' are not valid for all
  charset encodings, changed them with hexa values)
- corrected the estonian keyboard (s/asciircum/asciicircum/)

* Fri Nov 26 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- changed keymap.init and added a profile.d/ script to fix the BackSpace key;
  with the default being sending a "Delete", but user configurable.

* Tue Nov 23 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- added my collection of keyboards (in sync with DrakX installer)
- removed ro.map and sr.map from outside (they are already on console-data)
- added my compose.* files
- replaced the keymap.init by mine (uses compose.* files and correct the
  BakcSpace key (unless asked otherwise on /etc/sysconfig/keyboard))
- removed /usr/bin/fix_bs_and_del as it is no longer need (the keymap.init
  does the proper thing) 
- it is my birthday
- corrected the US intl (us-latin1) keymap to have dead keys

* Wed Sep  1 1999 Daouda LO <daouda@mandrakesoft.com>
- 0.2.2
- bug fixes

* Thu Jun  3 1999 Bernhard Rosenkrnzer <bero@mandrakesoft.com>
- Mandrake adaptions
- console-tools 0.2.0, console-data 1999.04.15
- Euro support
- Support for Windoze keys
- Support for Alt+AltGr=Compose
- cleanups

* Thu Apr 15 1999 Bill Nottingham <notting@redhat.com>
- make keytable %post handle us.map better

* Thu Apr 15 1999 Jeff Johnson <jbj@redhat.com>
- hotwire sun fonts.

* Wed Apr 14 1999 Bill Nottingham <notting@redhat.com>
- %post changes; just copy the user's configured font/map/etc.

* Wed Apr 14 1999 Matt Wilson <msw@redhat.com>
- added fonts RUSCII_*, koi8u_*, and acm koi8u2ruscii from
  Leon Kanter <leon@geon.donetsk.ua>

* Mon Apr 12 1999 Bill Nottingham <notting@redhat.com>
- removed sh-utils from prereq.
- added sed to prereq

* Fri Apr  9 1999 Jeff Johnson <jbj@redhat.com>
- more latin2 fonts (Peter Ivanyi).

* Thu Apr  8 1999 Bill Nottingham <notting@redhat.com>
- added sh-utils to prereq.

* Mon Apr  5 1999 Bill Nottingham <notting@redhat.com>
- /etc/sysconfig/console support
- add setsysfont to init script

* Mon Mar 29 1999 Peter Ivanyi <ivanyi@internet.sk>
- more fixes.

* Thu Mar 25 1999 Peter Ivanyi <ivanyi@internet.sk>
- add ucw-fonts-1.1.tar.gz
- delete obsolete sk keymaps from console-tools-1998.08.11.add-ons.

* Mon Mar 22 1999 Preston Brown <pbrown@redhat.com>
- added norwegian sun4 keymap support

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Fri Mar 12 1999 Jeff Johnson <jbj@redhat.com>
- update to 1999.03.02.

* Tue Feb 16 1999 Jeff Johnson <jbj@redhat.com>
- repackage for Red Hat 6.0

* Wed Jan 30 1999 Alex deVries <puffin@redhat.com>
- added amiga support for Jes Sorensen

* Mon Dec 07 1998 Jakub Jelinek <jj@ultra.linux.cz>
- some keymaps were including "*.map", which has to be
  replaced by "*.kmap"

* Fri Dec 04 1998 Jakub Jelinek <jj@ultra.linux.cz>
- upgrade to console-tools, added new sun keymaps,
  new sun fonts for latin0/1 and latin2, iso15.acm
  and iso02+euro.acm.
- Print the verbose messages only if verbose was 
  specified on command line.

* Thu Oct 01 1998 Cristian Gafton <gafton@redhat.com>
- added Euro (latin0) support from Guylhem Aznar

* Sun Sep 27 1998 Cristian Gafton <gafton@redhat.com>
- fix the name the ro and sr maps are installed under
- slovak keymaps
- ro.map and sr.map are welcomed to the club
- enable turkish again

* Mon Aug 24 1998 Cristian Gafton <gafton@redhat.com>
- KEYTABLE should not have the full patch name (%post hack)

* Fri Aug 21 1998 Jeff Johnson <jbj@redhat.com>
- install keymaps on tty0 w/o using (non-installed) open(1).

* Tue Jul 14 1998 Jeff Johnson <jbj@redhat.com>
- updated to 0.96a.

* Thu Jun 11 1998 Mikael Hedin <micce@irf.se>
- specify VT0 in case we use a serial console

* Wed Jun 10 1998 Jeff Johnson <jbj@redhat.com>
- quotes permit multiple keytables in keytable.init (problem #675)

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Thu May 07 1998 Donnie Barnes <djb@redhat.com>
- added some extra turkish support

* Thu Apr 30 1998 Cristian Gafton <gafton@redhat.com>
- fixes for building on alpha
- completed buildroot usage

* Thu Apr 23 1998 Michael K. Johnson <johnsonm@redhat.com>
- enhanced initscript

* Wed Apr 08 1998 Erik Troan <ewt@redhat.com>
- updated to 0.95

* Wed Mar 25 1998 Erik Troan <ewt@redhat.com>
- fixed /tmp exploit

* Wed Nov 05 1997 Donnie Barnes <djb@redhat.com>
- added SPARC stuff (finally!), Thanks to eduardo@medusa.es for most of it.
- added buildroot
- cleaned up the file list
- moved to rev 5 because the contrib ver rel was 4

* Mon Oct 20 1997 Donnie Barnes <djb@redhat.com>
- updated from 0.91 to 0.94
- added chkconfig support
- spec file cleanups

* Tue Jun 17 1997 Erik Troan <ewt@redhat.com>
- built against glibc
